/******************************************************************************
;  *    @ͺ                 : MC30P6290
;  *    @             : 2022.04.15
;  *    @˾/            : SINOMCU-FAE
;  *    @΢           : http://www.sinomcu.com/
;  *    @Ȩ                 : 2022 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                LBC   ﮵س
;  *                Զģʽ
;  *                P10D = 1  VCC>VBATVINLO
;  *                P11D = 1  س
;  *                P12D = 1  س
******************************************************************************/

#include "user.h"

/************************************************
;  *    @            : C_RAM
;  *    @˵                : RAM
;  *    @            :
;  *    @ز            :
;  ***********************************************/
void C_RAM(void)
{
    __asm
    movai 0x3F
    movra FSR
    movai 47
    movra 0x3F
    decr FSR
    clrr INDF
    djzr 0x3F
    goto $ -3;
    clrr 0x3F
    __endasm;
}

/************************************************
;  *    @            : IO_Init
;  *    @˵                : IOʼ
;  *    @            :
;  *    @ز            :
;  ***********************************************/
void IO_Init(void)
{
    P1 = 0x00;               //IOλ
    DDR1 = 0x00;             //1:input 0:output
    PUCON = 0xff;            //IO   0:Effective 1:invalid
    PDCON = 0xff;            //IO   0:Effective 1:invalid
    ODCON = 0x00;            //0:  1:©
}


/************************************************
;  *    @            : LBC_Init
;  *    @˵                : LBCʼ
;  *    @            :
;  *    @ز            :
;  ***********************************************/
void LBC_Init(void)
{
    LBCCR0 = 0x8a;           //Զ±ʱһVcvo=4.2VIcco=200mA
}

/************************************************
;  *    @            : Sys_Init
;  *    @˵                : ϵͳʼ
;  *    @            :
;  *    @ز            :
;  ***********************************************/
void Sys_Init(void)
{
    GIE = 0;
    C_RAM();
    IO_Init();
    LBC_Init();
    GIE = 1;
}

/************************************************
;  *    @            : main
;  *    @˵                : 
;  *    @            :
;  *    @ز            :
;  ***********************************************/
void main(void)
{
    Sys_Init();
    while (1)
    {
        if(VCCLIN==0 && (VCCLBT ==0 ))      //VCCVBATVINLO
        {
            P10D = 1;
        }
        else
        {
            P10D = 0;
        }
        if(BATFUL == 1)                     //س
        {
            P11D = 1;
        }
        if(LBCCHA ==1)                      //LBC
        {
            P12D =1;
        }
        if(CCOSTAT1 == 1 && (CCOSTAT0 == 0))
        {
            P13D = 1;
        }
    }
}

/************************************************
;  *    @            : interrupt
;  *    @˵                : жϺ
;  *    @            :
;  *    @ز            :
;  ***********************************************/
void int_isr(void) __interrupt
{
__asm
    movra _abuf
    swapar _STATUS
    movra _statusbuf
__endasm;

__asm
    swapar _statusbuf
    movra _STATUS
    swapr _abuf
    swapar _abuf
__endasm;
}

/**************************** end of file *********************************************/